Definition Interface
Fetch hub definition
GET/api/v6.1.0.5/hubs/{hub}/definition
| Query parameters | Prototype:
'fetch' ?: (
'locs'
| 'loc_props'
| 'loc_actions'
| 'channels'
| 'tables'
| 'cols'
| 'loc_groups'
| 'members'
| 'channel_actions'
| 'hub_actions'+
)
'channel' ?: ( + )
'loc' ?: ( + )
'table' ?: ( + )
'action_type' ?: ( + )
'cache_view_tstamp' ?:
|
| Request headers | Prototype:
X-Hvr-Classified-Access :
|
| Request body | None |
| Response headers | Prototype:
X-Hvr-View-Tstamp :
X-Hvr-Reload-Cache :
X-Hvr-Classified-Transport-Key :
|
| Response body (JSON) | Prototype:
'locs' ?: {
locname *: {
'props' ?: {
prop *: value
}
'actions' ?: (
{
'type' :
'params' ?: {
param *: val
}
}*
)
}
}
'channels' ?: {
channel *: {
'description' ?:
'loc_groups' ?: {
groupname *: {
'members' ?: ( loc* )
}
}
'tables' ?: {
tablename *: {
'base_name' ?:
'table_group' ?:
'cols' ?: {
colname *: {
'sequence' :
'key' ?:
'distrib_key' ?:
'data_type' :
'attributes' ?: {
'encoding' ?:
'nullable' ?:
'charlen' ?:
'bytelen' ?:
'prec' ?:
'scale' ?:
'timeprec' ?:
'dayprec' ?:
'yearprec' ?:
'bitlen' ?:
}
}
}
}
}
'actions' ?: (
{
'loc_scope' ?:
'table_scope' ?:
'type' :
'params' ?: {
param *: val
}
}*
)
}
}
'hub_actions' ?: (
{
'type' :
'params' ?: {
param *: val
}
}*
)
|
| Status codes | ✅ 200 OK ❌ 400 Bad Request |
| Required permissions | ReadOnly access level on hub |
Modify scope or parameters of action
POST/api/v6.1.0.5/hubs/{hub}/definition/action_modify
| Query parameters | None |
| Request headers | None |
| Request body (JSON) | Prototype:
'type' :
'old' : {
'channel' ?:
'loc_scope' ?:
'table_scope' ?:
'params' ?: {
param *: val
}
}
'new' : {
'channel' ?:
'loc_scope' ?:
'table_scope' ?:
'params' ?: {
param *: val |
}
}
|
| Response headers | None |
| Response body | None |
| Status codes | ✅ 204 No Content ❌ 400 Bad Request ❌ 404 Not Found: Action does not exist |
| Required permissions | ReadWrite access level on hub |
| Events | Creates the following event Definition_Change
'modify_action' : {
'type' :
'old' : {
'channel' ?:
'loc_scope' ?:
'table_scope' ?:
'params' ?: {
param *: val
}
}
'new' : {
'channel' ?:
'loc_scope' ?:
'table_scope' ?:
'params' ?: {
param *: val |
}
}
}
|
Replace action
POST/api/v6.1.0.5/hubs/{hub}/definition/action_replace
| Query parameters | None |
| Request headers | None |
| Request body (JSON) | Prototype:
'type' :
'old' : {
'channel' ?:
'loc_scope' ?:
'table_scope' ?:
'params' ?: {
param *: val
}
}
'new' : {
'channel' ?:
'loc_scope' ?:
'table_scope' ?:
'params' ?: {
param *: val
}
}
|
| Response headers | None |
| Response body | None |
| Status codes | ✅ 204 No Content ❌ 400 Bad Request ❌ 404 Not Found: Action does not exist |
| Required permissions | ReadWrite access level on hub |
| Events | Creates the following event Definition_Change
'replace_action' : {
'type' :
'old' : {
'channel' ?:
'loc_scope' ?:
'table_scope' ?:
'params' ?: {
param *: val
}
}
'new' : {
'channel' ?:
'loc_scope' ?:
'table_scope' ?:
'params' ?: {
param *: val
}
}
}
|
Fetch definition changes from events
GET/api/v6.1.0.5/hubs/{hub}/definition/change/events
| Query parameters | Prototype:
'direction' ?: 'redo' | 'undo'
'channel' ?: ( + )
'loc' ?: ( + )
'ev_tstamp_begin' ?:
'ev_tstamp_end' ?:
'ev_id' ?: ( + )
|
| Request headers | Prototype:
X-Hvr-Classified-Access :
|
| Request body | None |
| Response headers | Prototype:
X-Hvr-Classified-Transport-Key :
|
| Response body (JSON) | Prototype:
'changes' : (
{
'add_loc' : {
'loc' :
'props' : {
prop *: value
}
'actions' ?: (
{
'type' :
'params' ?: {
param *: val
}
}*
)
}
}
| {
'replace_loc' : {
'loc' :
'props' : {
prop *: value
}
'actions' ?: (
{
'type' :
'params' ?: {
param *: val
}
}*
)
}
}
| {
'delete_loc' : {
'loc' :
}
}
| {
'rename_loc' : {
'loc' :
'new_name' :
}
}
| {
'add_loc_props' : {
'loc' ?:
'props' : {
prop *: value
}
}
}
| {
'replace_loc_props' : {
'loc' :
'props' : {
prop *: value
}
}
}
| {
'modify_loc_props' : {
'loc' :
'props' : {
prop *: value |
}
}
}
| {
'delete_loc_props' : {
'loc' :
'props' : ( + )
}
}
| {
'add_loc_actions' : {
'loc' ?:
'actions' : (
{
'type' :
'params' ?: {
param *: val
}
}*
)
}
}
| {
'replace_loc_action_list' : {
'loc' :
'actions' : (
{
'type' :
'params' ?: {
param *: val
}
}*
)
}
}
| {
'delete_loc_actions' : {
'loc' :
'actions' : (
{
'type' :
'params' ?: {
param *: val
}
}*
)
}
}
| {
'add_channel' : {
'channel' :
'description' ?:
'loc_groups' ?: {
groupname *: {
'members' ?: ( loc* )
}
}
'tables' ?: {
tablename *: {
'base_name' ?:
'table_group' ?:
'cols' ?: {
colname *: {
'sequence' :
'key' ?:
'distrib_key' ?:
'data_type' :
'attributes' ?: {
'encoding' ?:
'nullable' ?:
'charlen' ?:
'bytelen' ?:
'prec' ?:
'scale' ?:
'timeprec' ?:
'dayprec' ?:
'yearprec' ?:
'bitlen' ?:
}
}
}
}
}
'actions' ?: (
{
'loc_scope' ?:
'table_scope' ?:
'type' :
'params' ?: {
param *: val
}
}*
)
}
}
| {
'replace_channel' : {
'channel' :
'description' ?:
'loc_groups' ?: {
groupname *: {
'members' ?: ( loc* )
}
}
'tables' ?: {
tablename *: {
'base_name' ?:
'table_group' ?:
'cols' ?: {
colname *: {
'sequence' :
'key' ?:
'distrib_key' ?:
'data_type' :
'attributes' ?: {
'encoding' ?:
'nullable' ?:
'charlen' ?:
'bytelen' ?:
'prec' ?:
'scale' ?:
'timeprec' ?:
'dayprec' ?:
'yearprec' ?:
'bitlen' ?:
}
}
}
}
}
'actions' ?: (
{
'loc_scope' ?:
'table_scope' ?:
'type' :
'params' ?: {
param *: val
}
}*
)
}
}
| {
'modify_channel' : {
'channel' :
'description' :
}
}
| {
'delete_channel' : {
'channel' :
}
}
| {
'rename_channel' : {
'channel' :
'new_name' :
}
}
| {
'add_loc_group' : {
'channel' ?:
'loc_group' :
'members' ?: ( loc* )
}
}
| {
'replace_loc_group' : {
'channel' :
'loc_group' :
'members' ?: ( loc* )
}
}
| {
'delete_loc_group' : {
'channel' :
'loc_group' :
}
}
| {
'rename_loc_group' : {
'channel' :
'loc_group' :
'new_name' :
}
}
| {
'add_loc_group_members' : {
'channel' ?:
'loc_group' :
'members' : ( loc* )
}
}
| {
'replace_loc_group_member_list' : {
'channel' :
'loc_group' :
'members' : ( loc* )
}
}
| {
'delete_loc_group_members' : {
'channel' :
'loc_group' :
'members' : ( loc* )
}
}
| {
'add_tables' : {
'channel' ?:
'tables' : {
tablename *: {
'base_name' ?:
'table_group' ?:
'cols' ?: {
colname *: {
'sequence' :
'key' ?:
'distrib_key' ?:
'data_type' :
'attributes' ?: {
'encoding' ?:
'nullable' ?:
'charlen' ?:
'bytelen' ?:
'prec' ?:
'scale' ?:
'timeprec' ?:
'dayprec' ?:
'yearprec' ?:
'bitlen' ?:
}
}
}
}
}
}
}
| {
'modify_table_list' : {
'channel' ?:
'tables' : {
tablename *: {
'base_name' ?:
'table_group' ?:
'cols' ?: {
colname *: {
'sequence' :
'key' ?:
'distrib_key' ?:
'data_type' :
'attributes' ?: {
'encoding' ?:
'nullable' ?:
'charlen' ?:
'bytelen' ?:
'prec' ?:
'scale' ?:
'timeprec' ?:
'dayprec' ?:
'yearprec' ?:
'bitlen' ?:
}
}
}
}
}
}
}
| {
'replace_table_list' : {
'channel' :
'tables' : {
tablename *: {
'base_name' ?:
'table_group' ?:
'cols' ?: {
colname *: {
'sequence' :
'key' ?:
'distrib_key' ?:
'data_type' :
'attributes' ?: {
'encoding' ?:
'nullable' ?:
'charlen' ?:
'bytelen' ?:
'prec' ?:
'scale' ?:
'timeprec' ?:
'dayprec' ?:
'yearprec' ?:
'bitlen' ?:
}
}
}
}
}
}
}
| {
'add_table' : {
'channel' ?:
'table' :
'base_name' ?:
'table_group' ?:
'cols' ?: {
colname *: {
'sequence' :
'key' ?:
'distrib_key' ?:
'data_type' :
'attributes' ?: {
'encoding' ?:
'nullable' ?:
'charlen' ?:
'bytelen' ?:
'prec' ?:
'scale' ?:
'timeprec' ?:
'dayprec' ?:
'yearprec' ?:
'bitlen' ?:
}
}
}
}
}
| {
'replace_table' : {
'channel' :
'table' :
'base_name' ?:
'table_group' ?:
'cols' ?: {
colname *: {
'sequence' :
'key' ?:
'distrib_key' ?:
'data_type' :
'attributes' ?: {
'encoding' ?:
'nullable' ?:
'charlen' ?:
'bytelen' ?:
'prec' ?:
'scale' ?:
'timeprec' ?:
'dayprec' ?:
'yearprec' ?:
'bitlen' ?:
}
}
}
}
}
| {
'modify_table' : {
'channel' :
'table' :
'base_name' ?:
'table_group' ?:
}
}
| {
'rename_table' : {
'channel' :
'table' :
'new_name' :
}
}
| {
'delete_tables' : {
'channel' :
'tables' : ( + )
}
}
| {
'add_cols' : {
'channel' ?:
'table' ?:
'cols' : {
colname *: {
'sequence' :
'key' ?:
'distrib_key' ?:
'data_type' :
'attributes' ?: {
'encoding' ?:
'nullable' ?:
'charlen' ?:
'bytelen' ?:
'prec' ?:
'scale' ?:
'timeprec' ?:
'dayprec' ?:
'yearprec' ?:
'bitlen' ?:
}
}
}
}
}
| {
'modify_col_list' : {
'channel' ?:
'table' ?:
|